RankingBoard = {}
RankingBoard.__index = RankingBoard

function RankingBoard.create()
	local result = { display = textCreateDisplay(), textitems = {} }
	for i,player in ipairs(getElementsByType('player')) do
		textDisplayAddObserver(result.display, player)
	end
	return setmetatable(result, RankingBoard)
end

function RankingBoard:add(player, time, position)
	if not position then
		position = #self.textitems/2 + 1
	end
	local positem = textCreateTextItem(tostring(position) .. ')', 0.04, 0.2 + (position-1)*0.02, 'medium', 255, 255, 255, 255, 1.5, 'right')
	if time then
		if not self.firsttime then
			self.firsttime = time
			time = ': ' .. msToTimeStr(time)
		else
			time = ': +' .. msToTimeStr(time - self.firsttime)
		end
	else
		time = ''
	end
	local playeritem = textCreateTextItem(getClientName(player) .. time, 0.05, 0.2 + (position-1)*0.02, 'medium', 255, 255, 255, 255, 1.5)
	textDisplayAddText(self.display, positem)
	table.insert(self.textitems, positem)
	textDisplayAddText(self.display, playeritem)
	table.insert(self.textitems, playeritem)
end

function msToTimeStr(ms)
	local centiseconds = tostring(math.floor(math.fmod(ms, 1000)/10))
	if #centiseconds == 1 then
		centiseconds = '0' .. centiseconds
	end
	local s = math.floor(ms / 1000)
	local seconds = tostring(math.fmod(s, 60))
	if #seconds == 1 then
		seconds = '0' .. seconds
	end
	local minutes = tostring(math.floor(s / 60))
	return minutes .. ':' .. seconds .. ':' .. centiseconds
end

function RankingBoard:clear()
	table.each(self.textitems, textDestroyTextItem)
	self.textitems = {}
end

function RankingBoard:destroy()
	textDestroyDisplay(self.display)
	self.display = nil
	self:clear()
end