local rootElement = getRootElement()

-- pack arguments on a table with an argument-count key
function npack(...)
   return {_n=select('#',...);...}
end

local mta_outputConsole = outputConsole
function outputConsole(message, toElement)
	if not toElement then
		outputServerLog(message)
	else
		mta_outputConsole(message, toElement)
		if toElement == rootElement then
			outputServerLog(message)
		end
	end
end

local mta_outputChatBox = outputChatBox
function outputChatBox(message, toElement)
	if not toElement then
		outputServerLog(message)
	else
		mta_outputChatBox(message, toElement, 250, 200, 200)
		if toElement == rootElement then
			outputServerLog(message)
		end
	end
end

-- dump the element tree
function map(element, outputTo, level)
	level = level or 0
	element = element or getRootElement()
	local indent = string.rep('  ', level)
	local eType = getElementType(element)
	local eID = getElementID(element)
	local eChildren = getElementChildren(element)
	
	local tagStart = '<'..eType
	if eID then
		tagStart = tagStart..' id="'..eID..'"'
	end
	for dataField, dataValue in pairs(getAllElementData(element)) do
		tagStart = tagStart..' '..dataField..'="'..tostring(dataValue)..'"'
	end
	
	if #eChildren < 1 then
		outputConsole(indent..tagStart..'"/>', outputTo)
	else
		outputConsole(indent..tagStart..'">', outputTo)
		for k, child in ipairs(eChildren) do
			map(child, outputTo, level+1)
		end
		outputConsole(indent..'</'..eType..'>', outputTo)
	end
end